<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class WarehouseTransferMaster extends BaseModel
{
    use HasFactory;

    protected $guarded = [];

    protected static function boot()
    {
        parent::boot(); // always call the parent boot
        static::addGlobalScope('typeScope', function ($builder) {
            if (auth()->check() && auth()->user()->shop_id != null) {
                $builder->where('transition_location_id', auth()->user()->shop_id);
            }
        });
        static::creating(function ($model) {
            if (auth()->check()) {
                $user = auth()->user();
                $model->transition_location_id = $user->shop_id;
                $model->transition_create_by = $user->id;
            }
        });

        static::updating(function ($model) {
            if (auth()->check()) {
                $model->transition_update_by = auth()->id(); // use user ID here
            }
        });
    }

    public function transferDetails()
    {
        return $this->hasMany(WarehouseTransferDetails::class)->with('productAttribute');
    }

    public function warehouseForm()
    {
        return $this->hasOne(Warehouse::class, 'id', 'from_warehouse_id');
    }

    public function warehouseTo()
    {
        return $this->hasOne(Warehouse::class, 'id', 'to_warehouse_id');
    }
}
